SystemOrganization addCategory: #MkAscension!

Object subclass: #LCGCard
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MkAscension'!

LCGCard subclass: #LCGApprentice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MkAscension'!

!LCGApprentice class methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 1/15/2015 21:01'!
runes
	"number of runes provided by the card"
	^1! !

!LCGCard class methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 1/15/2015 22:11'!
buyableCards
	^ self subclasses select: [ :c | c class canPerform: #cost ]! !

!LCGCard class methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 1/15/2015 20:58'!
honor
	"honor value of the card"
	^0! !

!LCGCard class methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 1/15/2015 21:12'!
isWarrior
	^ false! !

!LCGCard class methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 1/15/2015 21:01'!
power
	"power provided by the card"
	^0! !

!LCGCard class methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 1/15/2015 20:59'!
runes
	"number of runes provided by the card"
	^0! !

LCGCard subclass: #LCGDeathswornWarrior
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MkAscension'!

!LCGDeathswornWarrior class methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 1/15/2015 21:09'!
honor
	"honor value of the card"
	^1! !

!LCGDeathswornWarrior class methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 1/15/2015 21:10'!
isWarrior
	^ true! !

!LCGDeathswornWarrior class methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 1/15/2015 21:09'!
power
	"power provided by the card"
	^1! !

LCGCard subclass: #LCGHeavyInfantry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MkAscension'!

!LCGHeavyInfantry class methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 1/15/2015 21:16'!
cost
	"cost of the card"
	^2! !

!LCGHeavyInfantry class methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 1/15/2015 21:02'!
honor
	"honor value of the card"
	^1! !

!LCGHeavyInfantry class methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 1/15/2015 21:02'!
power
	"power provided by the card"
	^2! !

LCGCard subclass: #LCGMilitia
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MkAscension'!

!LCGMilitia class methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 1/15/2015 21:02'!
power
	"power provided by the card"
	^1! !

LCGCard subclass: #LCGMystic
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MkAscension'!

!LCGMystic class methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 1/15/2015 21:16'!
cost
	"cost of the card"
	^3! !

!LCGMystic class methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 1/15/2015 21:02'!
honor
	"honor value of the card"
	^1! !

!LCGMystic class methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 1/15/2015 21:02'!
runes
	"number of runes provided by the card"
	^2! !

Object subclass: #LCGHand
	instanceVariableNames: 'drawPile discardPile hand honor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MkAscension'!

!LCGHand class methodsFor: 'as yet unclassified ' stamp: 'MathiasKegelmann 1/15/2015 21:55'!
testHand
	| hand |
	hand := self basicNew.
	hand initialize: {LCGApprentice . LCGApprentice . LCGApprentice . LCGApprentice . LCGApprentice . LCGApprentice . LCGApprentice . LCGApprentice . LCGMilitia . LCGMilitia . LCGDeathswornWarrior}.
	^ hand! !

!LCGHand methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 1/15/2015 22:58'!
banishApprenticeOrMilitia
	discardPile remove: LCGApprentice 
		ifAbsent: [ discardPile remove: LCGMilitia ifAbsent: [  ] ]! !

!LCGHand methodsFor: 'as yet unclassified ' stamp: 'MathiasKegelmann 1/15/2015 21:45'!
drawCard
	(drawPile size < 1) ifTrue: [ 
		drawPile := Stack withAll: (discardPile shuffled).
		discardPile := Stack new ].
	hand add: (drawPile pop).
	! !

!LCGHand methodsFor: 'as yet unclassified ' stamp: 'MathiasKegelmann 1/15/2015 21:44'!
drawHand
	discardPile addAll: hand.
	hand := OrderedCollection new.
	5 timesRepeat: [ self drawCard ]! !

!LCGHand methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 1/15/2015 22:46'!
handContainsWarrior
	^ hand includes: LCGDeathswornWarrior ! !

!LCGHand methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 1/15/2015 22:39'!
honor
	^ ((hand, discardPile, drawPile) inject: 0 into: [ :sum :card | sum + card honor ]) + honor! !

!LCGHand methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 1/15/2015 22:30'!
initialize: cards
	honor := 0.
	drawPile := #().
	hand := #().
	discardPile := cards asOrderedCollection.
	self drawHand! !

!LCGHand methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 1/15/2015 22:49'!
playHand
	| runes power |
	self handContainsWarrior ifTrue: [ self banishApprenticeOrMilitia ].
	runes := hand inject: 0 into: [ :s :c | s + c runes ].
	power := hand inject: 0 into: [ :s :c | s + c power].
	(runes // 3) timesRepeat: [ discardPile add: LCGMystic ].
	(runes % 3 = 2) ifTrue: [ discardPile add: LCGHeavyInfantry ].
	honor := honor + (power // 2).
	self drawHand
	! !
